#!/usr/bin/perl
#
#file: frames.pl

use CGI qw/:all/;
use CGI::Carp qw(fatalsToBrowser);
use POSIX qw(strftime);
use Time::Local;
#
sub seqno
{
# Read a file for an IR sequence number for todays date. If it exists, 
# increment and resave it. If not create the file, create the seq no, and 
# save it.
#
# Written by Bill Ralph - 12/29/98
#
#
$LOCK_SH = 1;
$LOCK_EX = 2;
$LOCK_NB = 4;
$LOCK_UN = 8;

#
# Calculate the IR sequence number from todays date.
#
my $todays_date = strftime("%y%m%d", localtime);
my $todays_prefix = "SHA${todays_date}";
my $todays_seq = 1;
open(SEQ_FILE, "+</usr/local/etc/httpd/cgi-bin/IR_seq")
    or die("Unable to open IR Sequence file");
flock(SEQ_FILE, $LOCK_EX);
my @all = <SEQ_FILE>;
my @new_all = ();
foreach my $line (@all) {
   (my $prefix, my $seq) = split(/\./,$line);
   if ($prefix eq $todays_prefix) {
      $todays_seq = $seq + 1;
   } else {
      push(@new_all, $line);
   }
}
my $new_seqno = "${todays_prefix}.${todays_seq}";
push(@new_all, "$new_seqno\n");
seek(SEQ_FILE, 0, 0);
foreach $line (@new_all) {
   print SEQ_FILE $line;
}
close(SEQ_FILE);
flock(SEQ_FILE, $LOCK_UN);
return $new_seqno;
}
#
#
$today = strftime("%a %b %d, %Y - %T", localtime(time));
print header,
start_html(-title=>'Create an Incident Report',
           -author=>'Ima.Goodguy@goodguys.com',
           -background=>'/images/red_rock.gif');
if (!param) {
   $shadow_seqno = seqno();
   print h3({-align=>CENTER}, 
   start_form(-target=>'_self'),
   "GoodGuys Industries - Network Detection Report"),
   "GoodGuys Report No.: ",
   textfield(-name=>'rep_num',
             -size=>15,
             -value=>$shadow_seqno),
   p(),
   "   Mail Recipients: ",
   textfield(-name=>'mailto',
             -size=>60,
             -value=>'Core_IRs'),
   p(),
   "1. Report Date: $today", 
   p(),
   "2. Incident Date: ",
   textfield(-name=>'inci_date',
             -size=>20),
   p(),
   "3. Type of Incident: ",
   scrolling_list(-name=>'inci_type',
                  -size=>1,
                  -values=>['Denial of Service Attack', 'Smurf Attack',
                  'Land Attack', 'IMAP Attack', 'TraceRoute-Like Probe',
                  'Illegal Remote Login Attempts', 'RESET Scan', 'SYN Scan',
		  'SYN/RST Scan', 'Back Orifice Exploit Attempt',
                  'Port Scan', 'POP3 Scan', 'SNMP Probe/Scan',
                  'RPC/Portmap Attack', 'Sendmail Attack', 'DNS Zone Transfer',
                  'Single System Scan/Probe', 'SOCKS Exploit', 
                  'Multiple Port Scan/Attacks - Multiple Targets', 
                  'Informational Report', 'Foreign Access Attempt',
                  'Network Mapping Attempt', 'Unknown Probe type','ICMP Scan',
                  'SYN Flood','TCPMUX Scan', 'NETBIOS Probe']),
   p(),
   "4. Individuals Involved: ",
   p("Source: ",
   textfield(-name=>'indi_source',
             -size=>35)),
   p("Target(s): ",
   textfield(-name=>'indi_target',
             -size=>35)),
   p(),
   "5. Cost of this Incident: ",
   textfield(-name=>'inci_cost',
             -size=>70,
             -value=>'0.25 Hours, No Downtime, Stopped at Firewall'),
   p(),
   "6. Summary of Incident and Investigation Results: ",
   textarea(-name=>'summary',
            -rows=>10,
            -cols=>90,
            -wrap=>'physical'),
   p(),
   submit(-name=>'IR', -value=>'Send It'),
   end_form;
} else {
   $recipients = param('mailto');
   $rep_num = param('rep_num');
   $inci_date = param('inci_date');
   $inci_type = param('inci_type');
   $mail_subject = "$rep_num  : $inci_type";
   $indi_source = param('indi_source');
   $indi_target = param('indi_target');
   $inci_cost = param('inci_cost');
   $inci_summ = param('summary');
   $inci_summ =~ tr/\r//d;
   $mail_cmd = "/usr/sbin/sendmail -t -oi";
   open(MAILFILE, "|$mail_cmd");
#  open(MAILFILE, ">/tmp/IRmail$$");
#  print MAILFILE "$mail_cmd\n";
   print MAILFILE <<"EOF";
To: $recipients
From: The SHADOW Team <shadow\@goodguys.com>
Subject: $mail_subject

                  GoodGuys Industries - Network Security Division
                            Network Detection Report

                               Phone 000-555-1212      

GoodGuys Report No.: $rep_num

   1. Report Date: $today
   2. Incident Date: $inci_date
   3. Type of Incident: $inci_type
   4. Individuals Involved: 
         Source: $indi_source
         Target(s): $indi_target
   5. Cost of this Incident: $inci_cost
   6. Summary of Incident and Investigation Results: 

$inci_summ
EOF
   close(MAILFILE);
#
   print 
         a({-name=>'print', -href=>'javascript:window.print()'},
         img({-align=>'right',-src=>'/images/print.gif',-border=>'0'})),
         h3({-align=>CENTER},"GoodGuys Industries - Network Security Division"),
         h3({-align=>CENTER}," Network Detection Report"), 
         p(),
         hr(),
         center(strong("Phone 000-555-1212")), 
         p(),
         center(strong("GoodGuys Report No.:")," $rep_num"), p(),
         p(),
         strong("Sent To: $recipients"),
         p(),
         strong("Mail Subject: $mail_subject"),
         hr(),
         p(),
         strong("1. Report Date: "), "$today", p(),
         strong("2. Incident Date: "), "$inci_date", p(),
         strong("3. Type of Incident: "), "$inci_type", p(),
         strong("4. Individuals Involved: "), p(),
         ul(
         li(strong("Source: "), "$indi_source"), 
         li(strong("Target(s): "), "$indi_target"),
         ),
         strong("5. Cost of this Incident: "),"$inci_cost", p(),
         p(),
         strong("6. Summary of Incident and Investigation Results: "), p(),
         p(),
         pre("$inci_summ"), p(),
         hr(),
         h3({-align=>CENTER}," Mail sent.");
}
print end_html;
